"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.patchRelationship = void 0;
const tslib_1 = require("tslib");
function patchRelationship(options) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const { route: { id, relName }, body, } = options;
        const { rel, relationItem } = yield this.UtilsMethode.validateRelationRequestData(this.repository, id, relName, body);
        const patchBuilder = this.repository
            .createQueryBuilder()
            .relation(relName)
            .of(id);
        if (['one-to-many', 'many-to-many'].includes(relationItem.relationType)) {
            const currentEntities = yield patchBuilder.loadMany();
            const idsToDelete = currentEntities.map((entity) => entity.id);
            const idsToAdd = body !== null ? rel.map((i) => i.id) : [];
            yield patchBuilder.addAndRemove(idsToAdd, idsToDelete);
        }
        else if (body !== null) {
            const { id } = Array.isArray(body) ? body.shift() : body;
            yield patchBuilder.set(id);
        }
        else {
            yield patchBuilder.set(null);
        }
        return {
            data: body,
        };
    });
}
exports.patchRelationship = patchRelationship;
//# sourceMappingURL=patch-relationship.js.map