import { EntityMetadata, Repository, SelectQueryBuilder } from 'typeorm';
import { ObjectLiteral } from 'typeorm/common/ObjectLiteral';
import { Filter, ServiceOptions } from '../../../../types';
import { ResourceRequestObject } from '../../../../types-common/request';
import { RelationMetadata } from 'typeorm/metadata/RelationMetadata';
export declare type ResultQueryExpression = {
    expression: string;
    params: {
        name: string;
        val: string;
    } | null;
    selectInclude?: string;
};
export declare class UtilsMethode {
    static relationNameMapByEntity: Map<string, Set<string>>;
    static getParamName(field: string, i: number): string;
    static applyQueryFiltersTarget<T>(builder: SelectQueryBuilder<T>, filter: Filter<T>['target'], metadata: EntityMetadata): ResultQueryExpression[];
    static applyQueryFilterRelation<T>(builder: SelectQueryBuilder<T>, filter: Filter<T>['relation'], metadata: EntityMetadata): ResultQueryExpression[];
    static asyncIterateFindRelationships<T>(relationships: ResourceRequestObject<T>['data']['relationships'], repository: Repository<T>): AsyncIterable<{
        propsName: string;
        type: string;
        rel: ObjectLiteral | ObjectLiteral[];
        id: string | string[];
    }>;
    static validateRelationRequestData<T>(repository: Repository<T>, id: number | string, relName: string, body: ServiceOptions<T>['body']): Promise<{
        item: T;
        rel: ObjectLiteral | ObjectLiteral[];
        relationItem: RelationMetadata;
    }>;
}
